﻿local _G = _G
local MB = MacroBox
MB.LS = LibStub
MB.L = MB.LS("AceLocale-3.0"):GetLocale("MacroBox")
MB.slash = string.sub(_G.SLASH_CAST1, 1, 1)
MB.MACRONUM = "|cff00bfff%s|r: %d/%d"
local L = MB.L
local select, GetSpellInfo, format = select, GetSpellInfo, format
MB.frame:RegisterEvent("ADDON_LOADED")
MB.frame:RegisterEvent("PLAYER_LOGIN")
MB.frame:SetScript("OnEvent", function(...) MB:EventHandler(...) end)
MB.textures = {
	["general"] = {"Interface\\GossipFrame\\BinderGossipIcon", 0, 1, 0, 1},
	["hunter"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0, 0.25, 0.25, 0.5},
	["raid"] = {"Interface\\TARGETINGFRAME\\UI-RaidTargetingIcons", 0.75, 1, 0.25, 0.5},
	["deathknight"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0.25, 0.5, 0.5, 0.75},
	["druid"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0.75, 1, 0, 0.25},
	["mage"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0.25, 0.5, 0, 0.25},
	["monk"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0.5, 0.75, 0.5, 0.75},
	["paladin"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0, 0.25, 0.5, 0.75},
	["priest"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0.5, 0.75, 0.25, 0.5},
	["rogue"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0.5, 0.75, 0, 0.25},
	["shaman"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0.25, 0.5, 0.25, 0.5},
	["warrior"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0, 0.25, 0, 0.25},
	["warlock"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0.75, 1, 0.25, 0.5},
}

MB.MacroCommands = {"ACHIEVEMENTUI","ASSIST","BENCHMARK","CALENDAR","CANCELAURA","CANCELFORM","CANCELQUEUEDSPELL","CAST","CASTGLYPH","CASTRANDOM","CASTSEQUENCE","CHANGEACTIONBAR","CHANNEL","CHATLOG","CHAT_AFK","CHAT_ANNOUNCE",
"CHAT_BAN","CHAT_CINVITE","CHAT_DND","CHAT_HELP","CHAT_KICK","CHAT_MODERATE","CHAT_MODERATOR","CHAT_MUTE","CHAT_OWNER","CHAT_PASSWORD","CHAT_UNBAN","CHAT_UNMODERATOR","CHAT_UNMUTE","CLEAR","CLEARFOCUS",
"CLEARMAINASSIST","CLEARMAINTANK","CLEARTARGET","CLEAR_WORLD_MARKER","CLICK","COMBATLOG","CONSOLE","DISABLE_ADDONS","DISMISSBATTLEPET","DISMOUNT","DUEL","DUEL_CANCEL","DUMP","DUNGEONS","EMOTE",
"ENABLE_ADDONS","EQUIP","EQUIP_SET","EQUIP_TO_SLOT","EVENTTRACE","FOCUS","FOLLOW","FRAMESTACK","FRIENDS","GUILD","GUILDFINDER","GUILD_DEMOTE","GUILD_DISBAND","GUILD_HELP","GUILD_INFO","GUILD_INVITE",
"GUILD_LEADER","GUILD_LEADER_REPLACE","GUILD_LEAVE","GUILD_MOTD","GUILD_PROMOTE","GUILD_ROSTER","GUILD_UNINVITE","GUILD_WHO","HELP","IGNORE","INSPECT","INSTANCE_CHAT","INVITE","JOIN","LEAVE","LEAVEVEHICLE",
"LIST_CHANNEL","LOGOUT","LOOT_FFA","LOOT_GROUP","LOOT_MASTER","LOOT_NEEDBEFOREGREED","LOOT_ROUNDROBIN","LOOT_SETTHRESHOLD","MACRO","MACROHELP","MAINASSISTOFF","MAINASSISTON","MAINTANKOFF","MAINTANKON",
"OFFICER","OPEN_LOOT_HISTORY","PARTY","PET_AGGRESSIVE","PET_ASSIST","PET_ATTACK","PET_AUTOCASTOFF","PET_AUTOCASTON","PET_AUTOCASTTOGGLE","PET_DEFENSIVE","PET_FOLLOW","PET_MOVE_TO","PET_PASSIVE","PET_STAY",
"PLAYED","PROMOTE","PVP","QUIT","RAID","RAIDBROWSER","RAIDFINDER","RAID_INFO","RAID_WARNING","RANDOM","RANDOMFAVORITEPET","RANDOMPET","READYCHECK","RELOAD","REMOVEFRIEND","REPLY","RESETCHAT",
"SAVEGUILDROSTER","SAY","SCRIPT","SET_TITLE","SMART_WHISPER","STARTATTACK","STOPATTACK","STOPCASTING","STOPMACRO","STOPSPELLTARGET","STOPWATCH","SUMMON_BATTLE_PET","SWAPACTIONBAR","TARGET","TARGET_EXACT",
"TARGET_LAST_ENEMY","TARGET_LAST_FRIEND","TARGET_LAST_TARGET","TARGET_MARKER","TARGET_NEAREST_ENEMY","TARGET_NEAREST_ENEMY_PLAYER","TARGET_NEAREST_FRIEND","TARGET_NEAREST_FRIEND_PLAYER",
"TARGET_NEAREST_PARTY","TARGET_NEAREST_RAID","TEAM_CAPTAIN","TEAM_DISBAND","TEAM_INVITE","TEAM_QUIT","TEAM_UNINVITE","TIME","TOKEN","TRADE","UNIGNORE","UNINVITE","USE","USERANDOM","USE_TALENT_SPEC",
"VOICEMACRO","WARGAME","WHISPER","WHO","WORLD_MARKER","YELL"}

--tokenised to make them locale agnostic
-- // - slash/# command, :: = spell id, $ = item id, * = emote, & = newline
local function gsi(sid) return select(1, GetSpellInfo(sid)) end
-- ** 115 **
function MB:GenerateMacros()
	MB.Macros = {
	["general"] = {
		[1] = {"//5::19263&//5::1022&//5::44212&//5::54649&//5::1706&//5::130&//5::34477&//41&//126 VehicleExit()", L["Cancel auras"], 1},
		[2] = {"//999&//8 [mod:shift,nocombat]::116562&//132 [mod]&//34 [dead]&//143 [noexists]&//2 [help,nodead,combat]&//129 [harm,nodead]", L["Attack, or fish"], 2},
		[3] = {"//126 local a=\"gxWindow\";SetCVar(a,1-GetCVar(a));SetCVar(\"gxMaximize\",0);RestartGx()", L["Toggle screen mode"], 3},
		[4] = {"//126 SetCVar(\"cameraDistanceMax\",50)", L["Max camera distance"], 87},
	},
	["hunter"] = {
		[1] = {"//8$5512&//8 [@player,combat]::90361&//8 [@player,combat]::53480&//8 [combat]$76097&//8 [@player,nocombat]$82830", _G.SHOW_COMBAT_HEALING, 4},
		[2] = {"//102&//105&//103&//8::23145&//8::61684&//8::55709&//8 [@player]::126393", L["Pet rescue"], 5},
		[3] = {"//999::53271&//102&//105&//8 [@player]::53271&//8::23145&//8::61684&", gsi(53271), 6},
		[4] = {"//8$76089&//8 [nocombat]::23145&//8 [nocombat]::61684&//8 [combat]13&//8 [combat]14&//8 [combat]::3045&//8 [combat]::121818&//8 [combat]::53401&//98&//97&//8 [combat]::90355", L["Finishing attack"], 7},
		[5] = {format("//999&//8::20736&//46 %s", format(L["casts %s on %s"], gsi(20736), "%T")), gsi(20736), 8},
		[6] = {"//999&//8 [@mouseover,help,nodead][@focus,help,nodead][]::34477", gsi(34477),9},
		[7] = {"//999&//52 [@target,noexists]&//8 [@focus, exists]::34477&//2 [@focus]&//98&//8 [@target,exists]::1130", format("%s 2", gsi(34477)), 10},
		[8] = {"//999::1543&//8::19885&//96&//8::1001543", L["Rogue finder"], 11},
		[9] = {"//999&//141&//8 [@target, exists][@mouseover,harm,dead]::125048", gsi(125048), 12},
		[10] = {"//999::781&//8::5116&//8::781&//8::5118", L["Run away!"], 13},
		[11] = {"//999&//8 [@mouseover,harm][]::1513", gsi(1513), 79},
		[12] = {"//999::130392&//98&//159 13&//159 14&//8::19574&//8::53401&//8::130392", gsi(130392), 80},
		[13] = {"//999&//8 [@focus]::34490", gsi(34490), 81},
	},
	["raid"] = {
		[1] = {format("//126 SetRaidTargetIcon(\"target\",7)&//115 %s&/dbm pull 3", L["Pulling in 3 seconds"]), L["Pull with DBM warning"], 14},
		[2] = {"//36 ExtraActionButton1", L["Click boss action button"], 15},
		[3] = {"//126 if(xx or 0)==0 then xx=9 end xx=xx-1 SetRaidTarget(\"mouseover\",xx)", _G.BINDING_HEADER_RAID_TARGET, 16},
		[4] = {"//52 [@mouseover,exists][exists]&//132 [@mouseover,exists][exists]&//31", L["Focus macro"], 97},
	},
	["deathknight"] = {
		[1] = {"//999&//8 [@mouseover,help][]::61999", gsi(61999), 17},
		[2] = {"//999&//8::1049039;&//8 [@player]::47541", _G.SHOW_COMBAT_HEALING, 18},
		[3] = {"//999&//8::56815&//8::45529", gsi(45529), 19},
		[4] = {"//999::48743&//8::46584&//8::48743", gsi(48743), 20},
		[5] = {"//998&//8 [mod:alt]::48265;[mod:shift]::48263;[nomod]::48266", L["Presences"], 77},
		[6] = {"//999&//8 [@mouseover,exists,help,nodead][]::108199", gsi(108199), 88},
		[7] = {format("//999&//8 [@mouseover,exists,nodead,harm][]::77606&//126 SendChatMessage(\"%s\",\"WHISPER\",nil,GetUnitName(\"mouseover\")or GetUnitName(\"target\",1))", format(L["%s on you!"], gsi(77606))), gsi(77606), 89},
		[8] = {"//999&//8::1043265", gsi(43265), 91},
		[9] = {"//999&//8::1051052", gsi(51052), 92},
		[10] = {"//999&//129&//8 [@mouseover,exists,help,nodead][]::47541", gsi(47541), 93},
		[11] = {"//999&//129&//8 [@mouseover,exists,nodead,harm][]::130736", gsi(130736), 94},
		[12] = {"//999::46584&//126 PetDismiss()&//8::46584", gsi(46584), 95},
		[13] = {"//999::111673&//126 PetDismiss()&//8::111673", gsi(111673), 96},
		[14] = {"//999&//8 [mod:ctrl,@pet][]::47541", format("%s 2", gsi(47541)), 98},
		[15] = {"//999::51271&//159 13&//159 14&//8::51271&//8::46584", gsi(51271), 99},
	},
	["druid"] = {
		[1] = {"//999&//8 [@mouseover,help,nodead][@focus,help,nodead][@target,help,nodead][@player]::29166", gsi(29166), 21},
		[2] = {"//999&//126 SetCVar(\"autoUnshift\",0)&//8::132158&//8::5185&//126 SetCVar(\"autoUnshift\",1)", gsi(132158), 22},
		[3] = {"//999&//8 [@mouseover,help,nodead][]::88423", gsi(88423), 23},
		[4] = {"//999&//8 [combat]::58984;[nocombat,noform:3]::768;[nocombat,form:3]::1005215", gsi(5215), 78},
		[5] = {"//999&//8 [@target,help][@targettarget,help]::774", gsi(774), 100},
		[6] = {format("//999&//8 [nocombat]::50769&//132 [nocombat]&//8::20484&//46 %s", format(L["casts %s on %s"], gsi(50769), "%T")), format("%s/%s", gsi(50769), gsi(20484)), 101},
		[7] = {"//999&//8 [form:3]::5487&//8 [form:1][]::768", format("%s/%s", gsi(5487), gsi(768)), 49},
		[8] = {format("//999::24858&//8 [form:5,swimming,nocombat]::1066;[form:5,flyable,nocombat]::40120;[form:5,nocombat] %s;[form:5,combat]::783;::24858", L["Mount name"]), gsi(24858), 46},
		[9] = {"//999&//8 [@focus,btn:2][@player]::88423", format("%s 2", gsi(88423)), 53},
		[10] = {"//999&//8 [@mouseover,dead,combat][dead,combat]::20484;[@mouseover,dead][dead]::50769", format("%s/%s 2", gsi(50769), gsi(20484)), 47},
		[11] = {"//999&//8 [@mouseover,exists,help,stance:0][@target,stance:0,help]::102401&//8 [stance:1/3,@mouseover,exists,harm][stance:1/3,@target,exists,harm]::102401&//8 [stance:2/5/4]::102401", gsi(102401), 48},
		[12] = {"//999&//8 [mod:ctrl,@mouseover]::94447;[@focus,nodead][@mouseover]::94447&//126 UIErrorsFrame:Clear()", gsi(94447), 51},
	},
	["mage"] = {
		[1] = {"//999&//131&//8 [@focus,exists][]::30449", gsi(30449), 24},
		[2] = {"//999&//131&//8::1953", gsi(1953), 25},
		[3] = {"//999&//8 [@mouseover,nodead,help][nodead,help][@player]::130", gsi(130), 26},
		[4] = {format("//999&//31 [mod:alt]&//52 [@focus,noexists]&//8 [@focus,exists][@target,exists]::118&//46 %s", format(L["casts %s on %s"], gsi(118), "%F")), gsi(118), 27},
		[5] = {"//999&//131&//8::45438&//5::45438", gsi(45438), 102},
		[6] = {"//999&//131&//8::2139", gsi(2139), 103},
		[7] = {"//999&//8 [@mouseover,exists][]::475", gsi(475), 104},
		[8] = {"//999&//8 [@mouseover,harm,nodead,exists]::125430", gsi(125430), 105},
		[9] = {"//999&//8 [nomod]$65499&//8 [mod:shift]::42955&//8 [mod:ctrl]::42987",gsi(42855),115},
	},
	["monk"] = {
		[1] = {"//999::123904&//159 13&//159 14&//8::115399&//8::116740&//8::123904", gsi(123904), 28},
		[2] = {"//999::115080&//8::115203&//8::115080", gsi(115080), 29},
		[3] = {"//999&//8 [dead, help][mod:shift]::115178;[mod:SELFCAST,@player][btn:2,@player]::115450", L["Dispel and res"], 30},
		[4] = {"//998::116705&//8 [form:1]::103985&//8 [form:2]::116705&//8 [form:2]::136336", gsi(116705), 90},
	},
	["paladin"] = {
		[1] = {"//999&//8 [@player][@focus,mod:shift,exists][@target,btn:2,exists]::4987", gsi(4987), 31},
		[2] = {"//999&//8 [@focus,exists]Repentance; [@mouseover,harm]::20066", gsi(20066), 32},
		[3] = {"//999&//8 [@mouseover,help][help][@player]::20925", gsi(20925), 106},
		[4] = {"//999&//8 [@mouseover,help][@target,help][@targettarget,exists,help][@player]::4987", format("%s 2", gsi(4987)), 107},
		[5] = {"//999&//8 [@mouseover,help][@target,help][@targettarget,help][@player]::1022", gsi(1022), 108},
		[6] = {"//999&//8 [mod,@mouseover,help][mod,help]::1038;[@mouseover,help][help]::6940", gsi(6940), 109},
		[7] = {"//999&//8 [@focus,exists,harm][@focustarget,exists,harm][]::96231", gsi(96231), 110},
	},
	["priest"] = {
		[1] = {"//999&//8 [@mouseover,help,nodead][]::73325", gsi(73325), 33},
		[2] = {"//999&//8 [@mouseover, help]::17;[help]::17;[@targettarget,help]::17", gsi(17), 34},
		[3] = {"//999&//8 [@focus,help,nodead,exists][@player,nomod][mod,@target][@target,btn:2]::2061", gsi(2061), 35},
		[4] = {"//999&//8 [nopet]::34433&//98 [harm][@targettarget,harm]", gsi(34433), 36},
		[5] = {"//999&//8 [@target,harm,exists]::528;[@target,help,exists]::527", format("%s/%s", gsi(528), gsi(527)), 37},
		[6] = {"//999&//8 [mod:alt,@player][mod:ctrl,@target][@focus,exists,nodead,noharm][]::47788", gsi(47788), 38},
		[7] = {"//999&//131&//8 [@focus,exists,harm,nodead][]::15487", gsi(15487), 82},
		[8] = {"//999&//8 [@mouseovertarget,harm][@mouseover,harm][@targettarget,harm][harm]::585", gsi(585), 111},
		[9] = {"//999&//8 [@mouseovertarget,help]::121135", gsi(121135), 112},
	},
	["rogue"] = {
		[1] = {"//999&//144 [nodead,exists]&//8 [form:1/3,harm,nodead]::6770", L["Sap nearest enemy player"], 39},
		[2] = {format("//999::32645&//8 [@focus,exists][@%s,help]::57934&//8::32645", L["Player name"]), gsi(32645), 40},
		[3] = {"//999&//8::20577&//8::1784", gsi(20577), 41},
		[4] = {"//999&//8 [nocombat]::1784;::1856", format("%s/%s", gsi(1784), gsi(1856)), 83},
		[5] = {"//999&//8 [help][@focus,help][@targettarget,help]::57934", gsi(57934), 113},
		[6] = {"//999&//129&//159 13&//159 14&//8::13750&//8::121471", gsi(121471), 114},
	},
	["shaman"] = {
		[1] = {"//999&//131&//8 [@focus,exists][]::57994", gsi(57994), 42},
		[2] = {"//999&//131&//8 [@focus,exists][]::370", gsi(370), 43},
		[3] = {format("//999&//31 [modifier:alt]&//52 [@focus,noexists]&//8 [@focus,exists][@target,exists]::51514&//46 %s", format(L["casts %s on %s"], gsi(51514), "%F")), gsi(51514), 44},
		[4] = {format("//999&//31 [modifier:alt]&//52 [@focus,noexists]&//8 [@focus,exists][@target,exists]::76780&//46 %s", format(L["casts %s on %s"], gsi(76780), "%F")), gsi(76780), 45},
		[5] = {"//999&//52 [harm,noexists][harm,mod:shift]&//8 [@focus,exists,harm]::33786", gsi(33786), 50},
		[6] = {"//999&//132 [form]&//8 [harm]::2908;[dead,combat]::20484;[dead][mod:shift]::50769;[mod:SELFCAST,@player][btn:2,@player][]::2782", L["Dispel and res"], 52},
		[7] = {"//999&//8 [nomod]::8056&//8 [mod:ctrl]::8050&//8 [mod:alt]::8042", format("%s/%s/%s", gsi(8056), gsi(8050), gsi(8042)), 54},
		[8] = {format("//999&//8::974&//126 local s,t,n=\"%s\",\"target\" if IsSpellInRange(s,t)then SendChatMessage(\"%s\",\"WHISPER\",nil,UnitName(t))end", gsi(974), format("%s on you!", gsi(974))), gsi(974), 55},
		[9] = {"//999::403&//8::16188&//8::403", gsi(403), 56},
		[10] = {"//999::421&//8::16188&//8::421", gsi(421), 57},
		[11] = {"//999::77472&//8::16188&//8::77472", gsi(77472), 58},

	},
	["warrior"] = {
		[1] = {"//999&//8::46924&//5::46924", gsi(46924), 59},
		[2] = {"//999&//8 [help]::3411;::100", format("%s/%s", gsi(3411), gsi(100)), 60},
		[3] = {"//999::114192&//34 [help]&//137::114192&//8::3411&//8::114192&//141 [help]", gsi(114192), 61},
		[4] = {"//999&//8 [mod:ctrl]::114203;[mod:shift]::114192;[nomod]::114207", L["Banners"], 62},
		[5] = {"//999&//8 [form:1]::2458&//8 [form:2]::2457&//8 [form:3]::71", _G.WHC_TITLE_WARRIOR_2, 63},
		[6] = {"//999&//8 [@focus,mod:shift,exists][@focus,btn:2,exists][@mouseover,mod:alt,exists][]::355", gsi(355), 64},
		[7] = {"//999&//8::97462&//8::118038&//8::1114203&//8::71", gsi(97462), 65},
		[8] = {"//999::100&//129&//8::1719&//159 13&//159 14&//8::100&//126 UIErrorsFrame:Clear()", gsi(100), 66},
		[9] = {"//999&//8 [@mouseover,exists][@focus,exists][@target,exists]::23922", gsi(23922), 67},
		[10] = {"//999&//8 [@target,help]::3411;&//132 [help]&//146&//8::3411&//141", gsi(3411), 68},
		[11] = {"//999::78&//8::85730&//8::78", gsi(78), 69},
		[12] = {"//999::1680&//8::12328&//8::1680", gsi(1680), 70},
		[13] = {"//999::55694&//8::18499&//8::55694", gsi(55694), 71},
	},
	["warlock"] = {
		[1] = {format("//999&//8 [@mouseover,exists][]::20707&//46 %s", format(L["casts %s on %s"], gsi(20707), "%T")), gsi(20707), 72},
		[2] = {format("//999&//31 [mod:alt]&//52 [@focus,noexists]&//8 [@focus,exists][@target,exists]::115268&//46 %s", format(L["casts %s on %s"], gsi(115268), "%F")), gsi(115268), 73},
		[3] = {"//999&//8::5484&//8::6789&//8::1030283", format("%s/%s/%s", gsi(5484), gsi(6789), gsi(30283)), 74},
		[4] = {"//999::116858&//159 13&//159 14&//8::77801&//8::116858", gsi(116858), 75},
		[5] = {"//999::103958&//8::77801&//8::103958", gsi(103958), 76},
		[6] = {"//999&//8::108359&//159$19008", gsi(108359), 84},
		[7] = {"//999::86121&//8::74434&//8::86121", gsi(86121), 85},
		[8] = {"//999&//8 [pet:imp,mod:shift,@player][pet:imp,@mouseover,exists]::89808&//8 [pet:fel imp]::115276&//8 [pet:succubus]::6358&//8 [pet:observer]::115782&//8 [pet:felhunter]::19647&//8 [pet:felguard]::89766&//8 [pet:voidwalker]::7812", L["All pet abilities"], 86},
	},
}
end
MB:GenerateMacros()